import { checkDocument, removeDirectivesFromDocument } from 'apollo-utilities';
export function removeClientSetsFromDocument(query) {
    checkDocument(query);
    var docClone = removeDirectivesFromDocument([
        {
            test: function (directive) { return directive.name.value === 'client'; },
            remove: true,
        },
    ], query);
    if (docClone) {
        var nonClientDefinitions_1 = [];
        docClone.definitions.forEach(function (definition) {
            var isTypenameOnly = definition.selectionSet.selections.every(function (selection) {
                return (selection.kind === 'Field' &&
                    selection.name.value === '__typename');
            });
            if (!isTypenameOnly) {
                nonClientDefinitions_1.push(definition);
            }
        });
        docClone.definitions = nonClientDefinitions_1;
    }
    return docClone;
}
//# sourceMappingURL=removeClientSetsFromDocument.js.map